import time

import pytest


@pytest.fixture(params=[0])
def fake_view_changer(fake_view_changer):
    return fake_view_changer


def test_is_primary_disconnected_lost_none(fake_view_changer):
    fake_view_changer.node.lost_primary_at = None
    assert not fake_view_changer.is_primary_disconnected()


def test_is_primary_disconnected_primary_none(fake_view_changer):
    fake_view_changer.node.lost_primary_at = time.perf_counter()
    fake_view_changer.node.master_primary_name = None
    assert not fake_view_changer.is_primary_disconnected()


def test_is_primary_disconnected_primary_absent(fake_view_changer):
    fake_view_changer.node.lost_primary_at = time.perf_counter()
    fake_view_changer.node.master_primary_name = 'Alpha'
    assert not fake_view_changer.is_primary_disconnected()


def test_is_primary_disconnected(fake_view_changer):
    fake_view_changer.node.lost_primary_at = time.perf_counter()
    fake_view_changer.node.master_primary_name = 'Alpha'
    fake_view_changer.node.nodestack.conns.remove('Alpha')
    assert fake_view_changer.is_primary_disconnected()
